using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using mshtml;
using SHDocVw;
using System.Runtime.InteropServices;

namespace WebBrowserCustomization
{
  public class MainForm : System.Windows.Forms.Form, IDocHostUIHandler 
  {
    private AxSHDocVw.AxWebBrowser axWebBrowser1;
    private System.ComponentModel.IContainer components;
    private IHTMLDocument2 htmlDocument = null;

    ArrayList urlsVisited = new ArrayList();
    private System.Windows.Forms.ImageList imageList1;
    private System.Windows.Forms.ContextMenu myCustomContextMenu;
    private System.Windows.Forms.MenuItem menuItemPrint;
    private System.Windows.Forms.Panel panel1;
    private System.Windows.Forms.TextBox textBoxAddress;
    private System.Windows.Forms.ToolBar toolBar1;
    private System.Windows.Forms.ToolBarButton toolBarButtonBack;
    private System.Windows.Forms.ToolBarButton toolBarButtonForward;
    private System.Windows.Forms.ToolBarButton toolBarButtonStop;
    private System.Windows.Forms.ToolBarButton toolBarButtonRefresh;
    private System.Windows.Forms.ToolBarButton toolBarButtonHome;
    private System.Windows.Forms.ToolBarButton toolBarButtonSearch;
    private System.Windows.Forms.ToolBarButton toolBarButtonPrint;
    int currentUrlIndex = -1;  // no sites visited initially
    
    public MainForm()
    {
      InitializeComponent();

      toolBarButtonBack.Enabled = false;
      toolBarButtonForward.Enabled = false;
      toolBarButtonStop.Enabled = false;
      toolBarButtonRefresh.Enabled = false;
      toolBarButtonHome.Enabled = false;
      toolBarButtonSearch.Enabled = false;
      toolBarButtonPrint.Enabled = false;
      
      axWebBrowser1.GoHome();
    }

    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    protected override void Dispose( bool disposing )
    {
      if( disposing )
      {
        if(components != null)
        {
          components.Dispose();
        }
      }
      base.Dispose( disposing );
    }


    [STAThread]
    static void Main() 
    {
      Application.Run(new MainForm());
    }

    private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
    {
      Cursor.Current = Cursors.WaitCursor;

      try 
      {
        if (e.Button == toolBarButtonBack)
        {
          // axWebBrowser1.GoBack();  sometimes urlsVisited is out of sync with WebBrowser
          if (currentUrlIndex > 0)
            GotoURL(urlsVisited [--currentUrlIndex] as string);
        }

        else if (e.Button == toolBarButtonForward)
        {
          // axWebBrowser1.GoForward();  sometimes urlsVisited is out of sync with WebBrowser
          if (currentUrlIndex < urlsVisited.Count-1)
            GotoURL(urlsVisited [++currentUrlIndex] as string);
        }

        else if (e.Button == toolBarButtonStop) 
        {
          axWebBrowser1.Stop();

          toolBarButtonStop.Enabled = false;
        }
	
        else if (e.Button == toolBarButtonSearch)
          axWebBrowser1.GoSearch(); 

        else if (e.Button == toolBarButtonPrint)
          PrintPage();

        else if (e.Button == toolBarButtonRefresh)
        {
          object REFRESH_COMPLETELY = 3;
          axWebBrowser1.Refresh2(ref REFRESH_COMPLETELY); 

        }
			
        else if (e.Button == toolBarButtonHome)
          axWebBrowser1.GoHome();

      }
      finally 
      {
        Cursor.Current = Cursors.Default;
      }
    }

		#region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
      this.components = new System.ComponentModel.Container();
      System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
      this.axWebBrowser1 = new AxSHDocVw.AxWebBrowser();
      this.imageList1 = new System.Windows.Forms.ImageList(this.components);
      this.myCustomContextMenu = new System.Windows.Forms.ContextMenu();
      this.menuItemPrint = new System.Windows.Forms.MenuItem();
      this.panel1 = new System.Windows.Forms.Panel();
      this.textBoxAddress = new System.Windows.Forms.TextBox();
      this.toolBar1 = new System.Windows.Forms.ToolBar();
      this.toolBarButtonBack = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonForward = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonStop = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonRefresh = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonHome = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonSearch = new System.Windows.Forms.ToolBarButton();
      this.toolBarButtonPrint = new System.Windows.Forms.ToolBarButton();
      ((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).BeginInit();
      this.panel1.SuspendLayout();
      this.SuspendLayout();
      // 
      // axWebBrowser1
      // 
      this.axWebBrowser1.Dock = System.Windows.Forms.DockStyle.Fill;
      this.axWebBrowser1.Enabled = true;
      this.axWebBrowser1.Location = new System.Drawing.Point(0, 28);
      this.axWebBrowser1.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axWebBrowser1.OcxState")));
      this.axWebBrowser1.Size = new System.Drawing.Size(394, 245);
      this.axWebBrowser1.TabIndex = 2;
      this.axWebBrowser1.NavigateError += new AxSHDocVw.DWebBrowserEvents2_NavigateErrorEventHandler(this.axWebBrowser1_NavigateError);
      this.axWebBrowser1.NavigateComplete2 += new AxSHDocVw.DWebBrowserEvents2_NavigateComplete2EventHandler(this.axWebBrowser1_NavigateComplete2);
      this.axWebBrowser1.DocumentComplete += new AxSHDocVw.DWebBrowserEvents2_DocumentCompleteEventHandler(this.axWebBrowser1_DocumentComplete);
      this.axWebBrowser1.BeforeNavigate2 += new AxSHDocVw.DWebBrowserEvents2_BeforeNavigate2EventHandler(this.axWebBrowser1_BeforeNavigate2);
      // 
      // imageList1
      // 
      this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
      this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
      this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
      this.imageList1.TransparentColor = System.Drawing.Color.Lime;
      // 
      // myCustomContextMenu
      // 
      this.myCustomContextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                        this.menuItemPrint});
      // 
      // menuItemPrint
      // 
      this.menuItemPrint.Index = 0;
      this.menuItemPrint.Text = "Print";
      // 
      // panel1
      // 
      this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                         this.textBoxAddress,
                                                                         this.toolBar1});
      this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
      this.panel1.Name = "panel1";
      this.panel1.Size = new System.Drawing.Size(394, 28);
      this.panel1.TabIndex = 3;
      // 
      // textBoxAddress
      // 
      this.textBoxAddress.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.textBoxAddress.Location = new System.Drawing.Point(182, 4);
      this.textBoxAddress.Name = "textBoxAddress";
      this.textBoxAddress.Size = new System.Drawing.Size(208, 20);
      this.textBoxAddress.TabIndex = 1;
      this.textBoxAddress.Text = "";
      this.textBoxAddress.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBoxAddress_KeyDown);
      // 
      // toolBar1
      // 
      this.toolBar1.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
      this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
                                                                                this.toolBarButtonBack,
                                                                                this.toolBarButtonForward,
                                                                                this.toolBarButtonStop,
                                                                                this.toolBarButtonRefresh,
                                                                                this.toolBarButtonHome,
                                                                                this.toolBarButtonSearch,
                                                                                this.toolBarButtonPrint});
      this.toolBar1.ButtonSize = new System.Drawing.Size(18, 18);
      this.toolBar1.DropDownArrows = true;
      this.toolBar1.ImageList = this.imageList1;
      this.toolBar1.Name = "toolBar1";
      this.toolBar1.ShowToolTips = true;
      this.toolBar1.Size = new System.Drawing.Size(394, 25);
      this.toolBar1.TabIndex = 0;
      this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
      // 
      // toolBarButtonBack
      // 
      this.toolBarButtonBack.ImageIndex = 0;
      this.toolBarButtonBack.ToolTipText = "Go Back";
      // 
      // toolBarButtonForward
      // 
      this.toolBarButtonForward.ImageIndex = 1;
      this.toolBarButtonForward.ToolTipText = "Go Forward";
      // 
      // toolBarButtonStop
      // 
      this.toolBarButtonStop.ImageIndex = 2;
      this.toolBarButtonStop.ToolTipText = "Stop";
      // 
      // toolBarButtonRefresh
      // 
      this.toolBarButtonRefresh.ImageIndex = 3;
      this.toolBarButtonRefresh.ToolTipText = "Refresh";
      // 
      // toolBarButtonHome
      // 
      this.toolBarButtonHome.ImageIndex = 4;
      this.toolBarButtonHome.ToolTipText = "Home";
      // 
      // toolBarButtonSearch
      // 
      this.toolBarButtonSearch.ImageIndex = 5;
      this.toolBarButtonSearch.ToolTipText = "Search";
      // 
      // toolBarButtonPrint
      // 
      this.toolBarButtonPrint.ImageIndex = 6;
      this.toolBarButtonPrint.ToolTipText = "Print";
      // 
      // MainForm
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(394, 273);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.axWebBrowser1,
                                                                  this.panel1});
      this.Name = "MainForm";
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "MyCustomWebBrowser";
      ((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).EndInit();
      this.panel1.ResumeLayout(false);
      this.ResumeLayout(false);

    }
		#endregion

    private bool IsPrinterEnabled()
    {
      int response = 
        (int) axWebBrowser1.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_PRINT);
      return (response & (int) SHDocVw.OLECMDF.OLECMDF_ENABLED) != 0 ? 
        true : false;
    }

    private void PrintPage()
    {
      object o = "";

      // constants useful when printing
      SHDocVw.OLECMDID Print = SHDocVw.OLECMDID.OLECMDID_PRINT;

      // use this value to print without prompting
      // SHDocVw.OLECMDEXECOPT PromptUser =
      //  SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_PROMPTUSER;

      SHDocVw.OLECMDEXECOPT DontPromptUser =
        SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DONTPROMPTUSER;
  
      if (!IsPrinterEnabled() ) return;

      // print without prompting user
      axWebBrowser1.ExecWB(Print, DontPromptUser, ref o, ref o);

      // to prompt the user with printer settings
      // axWebBrowser1.ExecWB(Print, PromptUser, ref o, ref o);
    }
    
    public void GotoURL(String theURL) 
    {
      try 
      {
        Cursor.Current = Cursors.WaitCursor;
        Object o = null;
        axWebBrowser1.Navigate(theURL, ref o, ref o, ref o, ref o);
      } 
      finally 
      {
        Cursor.Current = Cursors.Default;
      }
    }

    private void textBoxAddress_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Return) 
        GotoURL(textBoxAddress.Text);
    }

    private void axWebBrowser1_BeforeNavigate2(object sender, AxSHDocVw.DWebBrowserEvents2_BeforeNavigate2Event e)
    {
      toolBarButtonStop.Enabled = true;
      Cursor.Current = Cursors.WaitCursor;
    }

    private void axWebBrowser1_NavigateComplete2(object sender, AxSHDocVw.DWebBrowserEvents2_NavigateComplete2Event e)
    {
      Cursor.Current = Cursors.Default;
 
      toolBarButtonStop.Enabled = false;
      toolBarButtonHome.Enabled = true;
      toolBarButtonSearch.Enabled = true;
      toolBarButtonRefresh.Enabled = true;

      // update the URL displayed in the address bar
      String s = e.uRL.ToString();
      textBoxAddress.Text = s;

      // update the list of visited URLs
      int i = urlsVisited.IndexOf(s);
      if (i >= 0)
        currentUrlIndex = i;
      else 
        currentUrlIndex = urlsVisited.Add(s);

      // enable / disable the Back and Forward buttons
      toolBarButtonBack.Enabled = (currentUrlIndex == 0) ? false : true;
      toolBarButtonForward.Enabled = 
        (currentUrlIndex >= urlsVisited.Count-1) ? false : true;

      // set the state of the Print button
      toolBarButtonPrint.Enabled = IsPrinterEnabled();
    }

    private void axWebBrowser1_NavigateError(object sender, AxSHDocVw.DWebBrowserEvents2_NavigateErrorEvent e)
    {
      Cursor.Current = Cursors.Default;

      toolBarButtonStop.Enabled = false;
      toolBarButtonHome.Enabled = true;
      toolBarButtonSearch.Enabled = true;
      toolBarButtonRefresh.Enabled = true;
    }

    private void axWebBrowser1_DocumentComplete(object sender, AxSHDocVw.DWebBrowserEvents2_DocumentCompleteEvent e)
    {
      htmlDocument = (IHTMLDocument2) axWebBrowser1.Document;
      if (htmlDocument == null) return;
      ICustomDoc customDoc = htmlDocument as ICustomDoc;
      if (customDoc == null) return;

      // tell MsHtml to call use our IDocHostUIHandler interface
      customDoc.SetUIHandler(this as IDocHostUIHandler);
    }
  
    #region IDocHostUIHandler methods

    public uint ShowContextMenu(uint dwID, ref tagPOINT pPoint,
                                [MarshalAs(UnmanagedType.IUnknown)] object pcmdtReserved,
                                [MarshalAs(UnmanagedType.IDispatch)] object pdispReserved)
    {
      // use this code to show a custom menu
      const int Ok = 0;
      Point p = new Point(pPoint.x, pPoint.y);
      p = PointToClient(p); 
      myCustomContextMenu.Show(this, p);
      throw new COMException("", Ok); // HRESULT = S_OK: MSHTML won't show its menu

      // use this code to let MsHtml shows its menu
      // const int Error = 1;
      // throw new COMException("", Error); // HRESULT = S_FALSE: MSHTML will show its menu
    }

    public void GetHostInfo(ref DOCHOSTUIINFO theHostUIInfo)
    {
      // turn three flags on
      theHostUIInfo.dwFlags |= (uint) (DOCHOSTUIFLAG.DOCHOSTUIFLAG_SCROLL_NO |
        DOCHOSTUIFLAG.DOCHOSTUIFLAG_NO3DBORDER |
        DOCHOSTUIFLAG.DOCHOSTUIFLAG_DISABLE_SCRIPT_INACTIVE);
    }
    
    public void ShowUI(uint dwID, 
      [MarshalAs(UnmanagedType.Interface)] IntPtr pActiveObject,
      [MarshalAs(UnmanagedType.Interface)] IntPtr pCommandTarget,
      [MarshalAs(UnmanagedType.Interface)] IntPtr pFrame,
      [MarshalAs(UnmanagedType.Interface)] IntPtr pDo) {}

    public void HideUI() {}
    public void UpdateUI() {}
    public void EnableModeless(int fEnable) {}
    public void OnDocWindowActivate(int fActivate) {}
    public void OnFrameWindowActivate(int fActivate) {}
    public void ResizeBorder(ref tagRECT prcBorder,
                             [MarshalAs(UnmanagedType.Interface)] IntPtr pUIWindow, 
                             int fRameWindow) {}
    
    public void TranslateAccelerator(ref tagMSG lpMsg, ref Guid pguidCmdGroup, uint nCmdID) 
    {
      const int Ok = 0;
      const int Error = 1;
      const int WM_KEYDOWN = 0x0100;
      const int VK_CONTROL = 0x11;
      
      if (lpMsg.message != WM_KEYDOWN)
        // allow message
        throw new COMException("", Error); // returns HRESULT = S_FALSE

      if (GetAsyncKeyState(VK_CONTROL) >= 0)
        // Ctrl key not pressed: allow message
        throw new COMException("", Error); // returns HRESULT = S_FALSE

      // disable the Ctrl-N and Ctrl-P accelerators
      lpMsg.wParam &= 0xFF; // get the virtual keycode
      if ( (lpMsg.wParam == 'N') || ((lpMsg.wParam == 'P')) )
        throw new COMException("", Ok); // returns HRESULT = S_OK

      // allow everything else
      throw new COMException("", Error); // returns HRESULT = S_FALSE
    }
    
    public void GetOptionKeyPath(ref string pchKey, uint dw) {} 

    public void GetDropTarget([MarshalAs(UnmanagedType.Interface)] IntPtr pDropTarget,
                              [MarshalAs(UnmanagedType.Interface)] ref IntPtr ppDropTarget)
    {
    }

    public void GetExternal([Out, MarshalAs(UnmanagedType.IDispatch)] out object ppDispatch) 
    {
      ppDispatch = null;
    }

    public void TranslateUrl(uint dwTranslate, string URLIn, ref string URLOut)   
      {
      URLOut = URLIn; // add code here to modify the Url the user is trying to
      // navigate to. Ex:
      //      // prevent users from leaving your web site
      //      if (URLIn.IndexOf("mywebsite.com") < 0)
      //        URLOut = "http://www.mywebsite.com";
      //      else
      //        URLOut = URLIn;
    }

    public void FilterDataObject(IDataObject pDO, ref IDataObject ppDORet)
    {
//      return doIn;
    }
   
    [DllImport("User32.dll")]
    public static extern short GetAsyncKeyState(int vKey);

    #endregion


  }
}
